Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/math/Operations.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/math/Operations.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/math/Operations.java	(revision 12)
@@ -57,8 +57,8 @@
 	@Override
 	public AbstractRange GenericArithmeticCover(AbstractRange type1, AbstractRange type2, ExpressionKind op)
 	{
-		Range<T> a = (Range<T>) type1;
-		Range<T> b = (Range<T>) type2;
+		final Range<T> a = (Range<T>) type1;
+		final Range<T> b = (Range<T>) type2;
 
 //		Range<T> a = type1 as Range<T>;
 //		Range<T> b = type2 as Range<T>;
@@ -71,8 +71,8 @@
 
 	public Range<T> GenericArithmeticCover(Range<T> type1, Range<T> type2, ExpressionKind op)
 	{
-		T defaultValue = m_basicOperations.getDefaultValue();
-		Range<T> result = type1.Create(defaultValue, defaultValue);
+		final T defaultValue = m_basicOperations.getDefaultValue();
+		final Range<T> result = type1.Create(defaultValue, defaultValue);
 
 		switch (op)
 		{
@@ -87,7 +87,7 @@
 				assert(type2 != null);
 				// we do some sort of resulttype = type1 - type2
 				// hence, do the unminus stuff with type 2
-				T spare = type2.max;
+				final T spare = type2.max;
 				type2.max = m_basicOperations.unMinus(type2.min);
 				type2.min = m_basicOperations.unMinus(spare);
 				// now it's the same as with sum.. but c# does not let us fall through..
@@ -101,24 +101,35 @@
 				break;
 			case idiv:
 			case div:
+				// get the closest values to 0 for the divisor.
 				assert(type2 != null);
-				type2.min = m_basicOperations.equal(type2.min, defaultValue) ?
-						m_basicOperations.unMinus(type2.precision) : type2.min;
-				type2.max = m_basicOperations.equal(type2.max, defaultValue) ?
-						type2.precision : type2.max;
-				// hmm, brute force.. is there some formula?
-				result.max = m_basicOperations.div(type1.min, type2.min);
+				final Range<T> closestToZero = type2.Create(defaultValue, defaultValue);
+				if (m_basicOperations.greater(type2.max, defaultValue) && (m_basicOperations.greater(type2.min, defaultValue) || m_basicOperations.equal(type2.min, defaultValue))) {
+					// divisor range [X...0+]
+					closestToZero.max = m_basicOperations.equal(type2.min, defaultValue) ? type2.precision : type2.min; // type2.min or type2.precision if that was 0
+					closestToZero.min = closestToZero.max;
+				} else if (m_basicOperations.smaller(type2.max, defaultValue) && (m_basicOperations.smaller(type2.min, defaultValue) || m_basicOperations.equal(type2.min, defaultValue))) {
+					// divisor range [0-...-X]
+					closestToZero.max = m_basicOperations.equal(type2.min, defaultValue) ? m_basicOperations.unMinus(type2.precision) : type2.min; // type2.min or -type2.precision if that was 0
+					closestToZero.min = closestToZero.max;
+				} else {
+					// divisor range [Y ... -X]
+					closestToZero.max = type2.precision;
+					closestToZero.min = m_basicOperations.unMinus(type2.precision);
+				}
+
+				result.max = m_basicOperations.div(type1.min, closestToZero.min);
 				result.min = result.max;
 
-				T tmp = m_basicOperations.div(type1.max, type2.min);
+				T tmp = m_basicOperations.div(type1.max, closestToZero.min);
 				result.max = m_basicOperations.smaller(result.max, tmp) ? tmp : result.max;
 				result.min = m_basicOperations.greater(result.min, tmp) ? tmp : result.min;
 
-				tmp = m_basicOperations.div(type1.min, type2.max);
+				tmp = m_basicOperations.div(type1.min, closestToZero.max);
 				result.max = m_basicOperations.smaller(result.max, tmp) ? tmp : result.max;
 				result.min = m_basicOperations.greater(result.min, tmp) ? tmp : result.min;
 
-				tmp = m_basicOperations.div(type1.max, type2.max);
+				tmp = m_basicOperations.div(type1.max, closestToZero.max);
 				result.max = m_basicOperations.smaller(result.max, tmp) ? tmp : result.max;
 				result.min = m_basicOperations.greater(result.min, tmp) ? tmp : result.min;
 				break;
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/parser/ooa.g
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/parser/ooa.g	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/parser/ooa.g	(revision 12)
@@ -20,6 +20,12 @@
 			 
   History
   ~~~~~~~
+Changes 1.09 to 1.10
+   - allow actions to be declared with empty parameter lists and "()" 
+   
+ Changes 1.08 to 1.09
+   ~ fix actionBody rule to allow multiple prioritized compositions (replace "?" by "*")
+
   Changes 1.07 to 1.08
     ~ remove support for Qualitative Action Systems
 
@@ -140,7 +146,8 @@
     Ulysses OO-Action System Parser
 
     Copyright Graz University of Technology 2009
-    Copyright AIT Austrian Institute of Technology 2013
+    Copyright AIT Austrian Institute of Technology 2013, 2016
+    Version 1.09
  */
  package org.momut.ooas.parser;
 
@@ -377,7 +384,7 @@
 	:	{actionType = FunctionTypeEnum.Internal;}
 		(T_CTRL {actionType = FunctionTypeEnum.Controllable;}| T_OBS {actionType = FunctionTypeEnum.Observable;}| )
 		 actionname=T_IDENTIFIER  {newAction = createNamedAction(actionname,actionType);}
-		(T_LPAREN methodParameterList[newAction]  T_RPAREN)? 
+		(T_LPAREN methodParameterList[newAction]?  T_RPAREN)? 
 		T_EQUAL	
 		(T_VAR localActionVars[newAction] )? 
 		body=discreteActionBody  
@@ -483,7 +490,7 @@
 actionBody[Block top]
 	returns [Block result]
 	:	{result = createPrioBlock(top); pushBlockToResolveStack(result);}
-		actionBodyParallel[result] (T_PRIO actionBodyParallel[result])? 
+		actionBodyParallel[result] (T_PRIO actionBodyParallel[result])*
 	;  
 	finally
 		{popBlockFromResolveStack(result);}
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/parser/ooaCustomParser.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/parser/ooaCustomParser.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/parser/ooaCustomParser.java	(revision 12)
@@ -499,7 +499,7 @@
 		if (rangeLow.getType() == ooaLexer.T_IDENTIFIER)
 		{
 			// see whether we can find the constant
-			final Identifier aconst = pState.currentScope.ResolveIdentifier(rangeLow.getText());
+			final Identifier aconst = pState.Lookup(rangeLow.getText());
 			if (aconst == null || aconst.kind() != IdentifierKind.Constant)
 				doError(rangeLow, String.format("Constant %s not found", rangeLow.getText()));
 			else if (aconst.type().kind() != TypeKind.IntType)
@@ -553,7 +553,7 @@
 		if (rangeLow.getType() == ooaLexer.T_IDENTIFIER)
 		{
 			// see whether we can find the constant
-			final Identifier aconst = pState.currentScope.ResolveIdentifier(rangeLow.getText());
+			final Identifier aconst = pState.Lookup(rangeLow.getText());
 			if (aconst == null || aconst.kind() != IdentifierKind.Constant)
 				doError(rangeLow, String.format("Constant %s not found", rangeLow.getText()));
 			else if (aconst.type().kind() != TypeKind.FloatType)
@@ -707,7 +707,7 @@
 		if (numOfElements.getType() == ooaLexer.T_IDENTIFIER)
 		{
 			// see whether we can find the constant
-			final Identifier aconst = pState.currentScope.ResolveIdentifier(numOfElements.getText());
+			final Identifier aconst = pState.Lookup(numOfElements.getText());
 			if (aconst == null || aconst.kind() != IdentifierKind.Constant)
 				doError(numOfElements, String.format("Constant %s not found", numOfElements.getText()));
 			else if (aconst.type().kind() != TypeKind.IntType)
@@ -744,7 +744,7 @@
 		if (numOfElements.getType() == ooaLexer.T_IDENTIFIER)
 		{
 			// see whether we can find the constant
-			final Identifier aconst = pState.currentScope.ResolveIdentifier(numOfElements.getText());
+			final Identifier aconst = pState.Lookup(numOfElements.getText());
 			if (aconst == null || aconst.kind() != IdentifierKind.Constant)
 				doError(numOfElements, String.format("Constant %s not found", numOfElements.getText()));
 			else if (aconst.type().kind() != TypeKind.IntType)
